Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/Manipulators/BiasedMultiVRPSolutionManipulator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/Manipulators/BiasedMultiVRPSolutionManipulator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/Manipulators/BiasedMultiVRPSolutionManipulator.cs	(revision 6851)
@@ -160,5 +160,5 @@
       OperationCollection next = new OperationCollection(successorOp);
       if (successor != null) {
-        SelectedOperatorParameter.ActualValue = new StringValue(successor.GetType().Name);
+        SelectedOperatorParameter.ActualValue = new StringValue(successor.Name);
 
         if (CreateChildOperation)
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/PermutationEncoding.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/PermutationEncoding.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/PermutationEncoding.cs	(revision 6851)
@@ -35,4 +35,22 @@
     #region IVRPEncoding Members
     public abstract List<Tour> GetTours();
+
+    public int GetTourIndex(Tour tour) {
+      int index = -1;
+
+      List<Tour> tours = GetTours();
+      for (int i = 0; i < tours.Count; i++) {
+        if (tours[i].IsEqual(tour)) {
+          index = i;
+          break;
+        }
+      }
+
+      return index;
+    }
+
+    public virtual int GetVehicleAssignment(int tour) {
+      return tour;
+    }
     #endregion
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/TourEncoding.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/TourEncoding.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/TourEncoding.cs	(revision 6851)
@@ -38,5 +38,5 @@
     
     #region IVRPEncoding Members
-    public void Repair() {
+    public virtual void Repair() {
       List<Tour> toBeRemoved = new List<Tour>();
       foreach (Tour tour in Tours) {
@@ -62,4 +62,21 @@
 
      return result;
+    }
+
+    public int GetTourIndex(Tour tour) {
+      int index = -1;
+
+      for (int i = 0; i < Tours.Count; i++) {
+        if (Tours[i].IsEqual(tour)) {
+          index = i;
+          break;
+        }
+      }
+
+      return index;
+    }
+
+    public virtual int GetVehicleAssignment(int tour) {
+      return tour;
     }
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinInsertionBasedCrossover.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinInsertionBasedCrossover.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinInsertionBasedCrossover.cs	(revision 6851)
@@ -28,4 +28,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Problems.VehicleRouting.ProblemInstances;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Potvin {
@@ -74,5 +75,5 @@
     }
 
-    private double CalculateCentroidDistance(Tour t1, Tour t2, DoubleMatrix coordinates) {
+    private double CalculateCentroidDistance(Tour t1, Tour t2, IVRPProblemInstance instance) {
       double xSum = 0;
       double ySum = 0;
@@ -80,6 +81,6 @@
 
       for (int i = 0; i < t1.Stops.Count; i++) {
-        xSum += coordinates[t1.Stops[i], 0];
-        ySum += coordinates[t1.Stops[i], 1];
+        xSum += instance.GetCoordinates(t1.Stops[i])[0];
+        ySum += instance.GetCoordinates(t1.Stops[i])[1];
       }
       c1X = xSum / t1.Stops.Count;
@@ -87,6 +88,6 @@
 
       for (int i = 0; i < t2.Stops.Count; i++) {
-        xSum += coordinates[t2.Stops[i], 0];
-        ySum += coordinates[t2.Stops[i], 1];
+        xSum += instance.GetCoordinates(t2.Stops[i])[0];
+        ySum += instance.GetCoordinates(t2.Stops[i])[1];
       }
       c2X = xSum / t1.Stops.Count;
@@ -98,9 +99,9 @@
     }
 
-    private double CalculateMeanCentroidDistance(Tour t1, IList<Tour> tours, DoubleMatrix coordinates) {
+    private double CalculateMeanCentroidDistance(Tour t1, IList<Tour> tours, IVRPProblemInstance instance) {
       double sum = 0;
 
       for (int i = 0; i < tours.Count; i++) {
-        sum += CalculateCentroidDistance(t1, tours[i], coordinates);
+        sum += CalculateCentroidDistance(t1, tours[i], instance);
       }
 
@@ -108,5 +109,5 @@
     }
 
-    private int SelectCityBiasedByNeighborDistance(IRandom random, Tour tour) {
+    private int SelectCityBiasedByNeighborDistance(IRandom random, Tour tour, IVRPEncoding solution) {
       int cityIndex = -1;
 
@@ -120,5 +121,5 @@
           next = tour.Stops[i + 1];
         double distance = ProblemInstance.GetDistance(
-          tour.Stops[i], next);
+          tour.Stops[i], next, solution);
 
         int prev;
@@ -128,5 +129,5 @@
           prev = tour.Stops[i - 1];
         distance += ProblemInstance.GetDistance(
-          tour.Stops[i], prev);
+          tour.Stops[i], prev, solution);
 
         probabilities[i] = distance;
@@ -168,5 +169,5 @@
       for (int i = 0; i <= tour.Stops.Count; i++) {
         bool feasible;
-        double detour = ProblemInstance.GetInsertionCosts(eval, city, 0, i, out feasible);
+        double detour = ProblemInstance.GetInsertionCosts(eval, individual, city, 0, i, out feasible);
         if (feasible || allowInfeasible) {
           if (place < 0 || detour < minDetour) {
@@ -195,5 +196,6 @@
 
     protected override PotvinEncoding Crossover(IRandom random, PotvinEncoding parent1, PotvinEncoding parent2) {
-      PotvinEncoding child = new PotvinEncoding(ProblemInstance);
+      PotvinEncoding child = parent1.Clone() as PotvinEncoding;
+      child.Tours.Clear();
 
       bool allowInfeasible = AllowInfeasibleSolutions.Value.Value;
@@ -213,7 +215,7 @@
         List<int> R2 = new List<int>();
 
-        double r = CalculateMeanCentroidDistance(r1, parent2.Tours, ProblemInstance.Coordinates);
+        double r = CalculateMeanCentroidDistance(r1, parent2.Tours, ProblemInstance);
         foreach (Tour tour in parent2.Tours) {
-          if (CalculateCentroidDistance(r1, tour, ProblemInstance.Coordinates) <= r) {
+          if (CalculateCentroidDistance(r1, tour, ProblemInstance) <= r) {
             R2.AddRange(tour.Stops);
           }
@@ -227,9 +229,11 @@
         int removed = random.Next(1, r1.Stops.Count + 1);
         for (int i = 0; i < removed; i++) {
-          childTour.Stops.RemoveAt(SelectCityBiasedByNeighborDistance(random, childTour));
+          childTour.Stops.RemoveAt(SelectCityBiasedByNeighborDistance(random, childTour, child));
         }
 
         //REPAIR - add cities from R2
-        int maxCount = random.Next(1, Math.Min(5, R2.Count));
+        int maxCount = 1;
+        if(R2.Count > 1)
+          maxCount = random.Next(1, Math.Min(5, R2.Count));
         int count = 0;
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinRouteBasedCrossover.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinRouteBasedCrossover.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinRouteBasedCrossover.cs	(revision 6851)
@@ -26,4 +26,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Common;
+using HeuristicLab.Problems.VehicleRouting.Encodings.ExtendedPotvin;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Potvin {
@@ -57,5 +58,20 @@
 
       child.Tours.Remove(replaced);
-      child.Tours.Add(replacing);
+      child.Tours.Insert(tourParent2, replacing);
+
+      if (parent1 is ExtendedPotvinEncoding && child is ExtendedPotvinEncoding) {
+        Permutation vehicleAssignment = (child as ExtendedPotvinEncoding).VehicleAssignment;
+
+        int vehicle = vehicleAssignment[tourParent2];
+        int vehicle2 = (parent1 as ExtendedPotvinEncoding).VehicleAssignment[tourParent1];
+        vehicleAssignment[tourParent2] = vehicle2;
+
+        for (int i = 0; i < vehicleAssignment.Length; i++) {
+          if (vehicleAssignment[i] == vehicle2 && i != tourParent2) {
+            vehicleAssignment[i] = vehicle;
+            break;
+          }
+        }        
+      }
 
       foreach (int city in replaced.Stops)
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinSequenceBasedCrossover.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinSequenceBasedCrossover.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Crossovers/PotvinSequenceBasedCrossover.cs	(revision 6851)
@@ -67,6 +67,7 @@
         newTour.Stops.Add(tour2.Stops[i]);
 
+      int tour1Index = child.Tours.IndexOf(tour1);
       child.Tours.Remove(tour1);
-      child.Tours.Add(newTour);
+      child.Tours.Insert(tour1Index, newTour);
 
       foreach (int city in tour1.Stops)
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Manipulators/PotvinCustomerRelocationManipulator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Manipulators/PotvinCustomerRelocationManipulator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Manipulators/PotvinCustomerRelocationManipulator.cs	(revision 6851)
@@ -67,5 +67,5 @@
         for (int i = 0; i < route1.Stops.Count; i++) {
           int stop = route1.Stops[i];
-          if (ProblemInstance.Demand[stop] < 0) {
+          if (ProblemInstance.GetDemand(stop) < 0) {
             int source = pdp.PickupDeliveryLocation[stop];
 
@@ -158,5 +158,5 @@
 
             //drive there
-            double currentDistace = vrptw.GetDistance(start, end);
+            double currentDistace = vrptw.GetDistance(start, end, individual);
             time += currentDistace;
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeExhaustiveMoveGenerator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeExhaustiveMoveGenerator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeExhaustiveMoveGenerator.cs	(revision 6851)
@@ -62,8 +62,8 @@
             if (k != i) {
               int city1 = individual.Tours[i].Stops[j];
-              if (pdp == null || pdp.Demand[city1] >= 0) {
+              if (pdp == null || pdp.GetDemand(city1) >= 0) {
                 for (int l = 0; l < individual.Tours[k].Stops.Count; l++) {
                   int city2 = individual.Tours[k].Stops[l];
-                  if (pdp == null || pdp.Demand[city2] >= 0) {
+                  if (pdp == null || pdp.GetDemand(city2) >= 0) {
                     bool valid = pdp == null ||
                       (pdp.PickupDeliveryLocation[city2] != pdp.PickupDeliveryLocation[city1] &&
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeSingleMoveGenerator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeSingleMoveGenerator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDExchange/PotvinPDExchangeSingleMoveGenerator.cs	(revision 6851)
@@ -62,5 +62,5 @@
       IPickupAndDeliveryProblemInstance pdp = problemInstance as IPickupAndDeliveryProblemInstance;
       for (int i = 1; i <= individual.Cities; i++) {
-        if (pdp == null || pdp.Demand[i] >= 0)
+        if (pdp == null || pdp.GetDemand(i) >= 0)
           cities.Add(i);
       }
@@ -84,5 +84,5 @@
         foreach (int stop in newTour.Stops) {
           if (pdp == null ||
-            (pdp.Demand[stop] >= 0 &&
+            (pdp.GetDemand(stop) >= 0 &&
              pdp.PickupDeliveryLocation[stop] != pdp.PickupDeliveryLocation[city] &&
              pdp.PickupDeliveryLocation[stop] != city &&
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeExhaustiveMoveGenerator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeExhaustiveMoveGenerator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeExhaustiveMoveGenerator.cs	(revision 6851)
@@ -54,5 +54,5 @@
 
       for (int i = 1; i <= problemInstance.Cities.Value; i++) {
-        if (pdp == null || pdp.Demand[i] >= 0) {
+        if (pdp == null || pdp.GetDemand(i) >= 0) {
           int tour = individual.Tours.FindIndex(t => t.Stops.Contains(i));
 
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeMoveMaker.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeMoveMaker.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeMoveMaker.cs	(revision 6851)
@@ -74,5 +74,5 @@
           if (positionToAvoid != i || positionToAvoid2 != j || stops == 0) {
             bool feasible;
-            double targetCosts = problemInstance.GetInsertionCosts(tourEval, target, 0, j, out feasible);
+            double targetCosts = problemInstance.GetInsertionCosts(tourEval, solution, target, 0, j, out feasible);
 
             double costs = sourceCosts + targetCosts;
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeSingleMoveGenerator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeSingleMoveGenerator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDRearrange/PotvinPDRearrangeSingleMoveGenerator.cs	(revision 6851)
@@ -62,5 +62,5 @@
       IPickupAndDeliveryProblemInstance pdp = problemInstance as IPickupAndDeliveryProblemInstance;
       for (int i = 1; i <= individual.Cities; i++) {
-        if(pdp == null || pdp.Demand[i] >= 0)
+        if(pdp == null || pdp.GetDemand(i) >= 0)
           cities.Add(i);
       }
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftExhaustiveMoveGenerator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftExhaustiveMoveGenerator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftExhaustiveMoveGenerator.cs	(revision 6851)
@@ -62,5 +62,5 @@
             if (k != i) {
               int city = individual.Tours[i].Stops[j];
-              if (pdp == null || pdp.Demand[city] >= 0) {
+              if (pdp == null || pdp.GetDemand(city) >= 0) {
                 PotvinPDShiftMove move = new PotvinPDShiftMove(
                   city, i, k, individual);
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftSingleMoveGenerator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftSingleMoveGenerator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/Moves/PickupDelivery/PDShift/PotvinPDShiftSingleMoveGenerator.cs	(revision 6851)
@@ -62,5 +62,5 @@
       IPickupAndDeliveryProblemInstance pdp = problemInstance as IPickupAndDeliveryProblemInstance;
       for (int i = 1; i <= individual.Cities; i++) {
-        if(pdp == null || pdp.Demand[i] >= 0)
+        if(pdp == null || pdp.GetDemand(i) >= 0)
           cities.Add(i);
       }
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/PotvinEncoding.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/PotvinEncoding.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Potvin/PotvinEncoding.cs	(revision 6851)
@@ -45,5 +45,5 @@
 
     [StorableConstructor]
-    private PotvinEncoding(bool serializing)
+    protected PotvinEncoding(bool serializing)
       : base(serializing) {
     }
@@ -75,5 +75,5 @@
 
     public double GetTourLength(Tour tour) {
-      return tour.GetTourLength(ProblemInstance);
+      return tour.GetTourLength(ProblemInstance, this);
     }
 
@@ -87,5 +87,5 @@
         if (positionToAvoid != i) {
           bool feasible;
-          double quality = ProblemInstance.GetInsertionCosts(eval, city, 0, i, out feasible);
+          double quality = ProblemInstance.GetInsertionCosts(eval, this, city, 0, i, out feasible);
           if (place < 0 || quality < minQuality) {
             place = i;
@@ -115,6 +115,6 @@
           for (int i = 0; i <= Tours[tour].Stops.Count; i++) {
             bool feasible;
-            double detour = ProblemInstance.GetInsertionCosts(eval, city, tour, i, out feasible);
-            
+            double detour = ProblemInstance.GetInsertionCosts(eval, this, city, tour, i, out feasible);
+
             if (feasible || allowInfeasible) {
               if (route < 0 || detour < minDetour) {
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs	(revision 6851)
@@ -48,5 +48,5 @@
     }
 
-    public double GetTourLength(IVRPProblemInstance instance) {
+    public double GetTourLength(IVRPProblemInstance instance, IVRPEncoding solution) {
       double length = 0;
 
@@ -60,5 +60,5 @@
 
         for (int i = 1; i < cities.Count; i++) {
-          length += instance.GetDistance(cities[i - 1], cities[i]);
+          length += instance.GetDistance(cities[i - 1], cities[i], solution);
         }
       }
@@ -66,4 +66,16 @@
       return length;
     }
+
+    public bool IsEqual(Tour tour) {
+      bool equal = (tour != null) && (tour.Stops.Count == Stops.Count);
+      int index = 0;
+
+      while (equal && index < Stops.Count) {
+        equal = equal && tour.Stops[index] == Stops[index];
+        index++;
+      }      
+
+      return equal;
+    }
   }
 }
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs	(revision 6851)
@@ -77,8 +77,8 @@
 
         if (ProblemInstance.GetDistance(
-          child[i] + 1, parent1[(i + 1) % child.Length] + 1)
+          child[i] + 1, parent1[(i + 1) % child.Length] + 1, child)
           <
           ProblemInstance.GetDistance(
-          child[i] + 1, parent2[(i + 1) % child.Length] + 1)) {
+          child[i] + 1, parent2[(i + 1) % child.Length] + 1, child)) {
           child[(i + 1) % child.Length] = parent1[(i + 1) % child.Length];
           Swap(parent2, parent2[(i + 1) % child.Length], parent1[(i + 1) % child.Length]);
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs	(revision 6851)
@@ -79,8 +79,8 @@
 
         if (ProblemInstance.GetDistance(
-         child[i] + 1, p1[parent1Index] + 1)
+         child[i] + 1, p1[parent1Index] + 1, child)
          <
          ProblemInstance.GetDistance(
-         child[i] + 1, p2[parent2Index] + 1)) {
+         child[i] + 1, p2[parent2Index] + 1, child)) {
           child[(i + 1) % child.Length] = p1[parent1Index];
         } else {
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 6851)
@@ -170,4 +170,9 @@
     <Compile Include="Encodings\Alba\Moves\ThreeOpt\AlbaStochasticTranslocationSingleMoveGenerator.cs" />
     <Compile Include="Encodings\Alba\Moves\ThreeOpt\IAlbaTranslocationMoveOperator.cs" />
+    <Compile Include="Encodings\ExtendedPotvin\Creators\ExtendedPotvinCreator.cs" />
+    <Compile Include="Encodings\ExtendedPotvin\Crossovers\ExtendedPotvinCrossover.cs" />
+    <Compile Include="Encodings\ExtendedPotvin\IExtendedPotvinOperator.cs" />
+    <Compile Include="Encodings\ExtendedPotvin\ExtendedPotvinEncoding.cs" />
+    <Compile Include="Encodings\ExtendedPotvin\Manipulators\ExtendedPotvinManipulator.cs" />
     <Compile Include="Encodings\General\Creators\MultiVRPSolutionCreator.cs" />
     <Compile Include="Encodings\General\Creators\VRPCreator.cs" />
@@ -202,7 +207,7 @@
     <Compile Include="Encodings\GVR\Manipulators\GVRManipulator.cs" />
     <Compile Include="Encodings\GVR\Manipulators\GVRSwapManipulator.cs" />
-    <Compile Include="Encodings\Potvin\Creators\PushForwardInsertionCreator.cs" />
+    <Compile Include="Encodings\ExtendedPotvin\Creators\PushForwardInsertionCreator.cs" />
     <Compile Include="Encodings\Potvin\Creators\PotvinCreator.cs" />
-    <Compile Include="Encodings\Potvin\Creators\IterativeInsertionCreator.cs" />
+    <Compile Include="Encodings\ExtendedPotvin\Creators\IterativeInsertionCreator.cs" />
     <Compile Include="Encodings\Potvin\Crossovers\PotvinCrossover.cs" />
     <Compile Include="Encodings\Potvin\Crossovers\PotvinInsertionBasedCrossover.cs" />
@@ -292,12 +297,17 @@
     <Compile Include="Interfaces\IVRPEncoding.cs" />
     <Compile Include="Interfaces\IVRPProblemInstance.cs" />
+    <Compile Include="Parsers\CordeauParser.cs" />
     <Compile Include="Parsers\LiLimParser.cs" />
+    <Compile Include="ProblemInstances\MultiDepotVRP\MDCVRP\MDCVRPEvaluator.cs" />
+    <Compile Include="ProblemInstances\MultiDepotVRP\MDCVRP\MDCVRPProblemInstance.cs" />
+    <Compile Include="ProblemInstances\MultiDepotVRP\MultiDepotVRPProblemInstance.cs" />
+    <Compile Include="ProblemInstances\MultiDepotVRP\MultiDepotVRPEvaluator.cs" />
     <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPTW\CVRPPDTW\CVRPPDTWProblemInstance.cs" />
     <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPTW\CVRPPDTW\CVRPPDTWEvaluation.cs" />
     <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPTW\CVRPPDTW\CVRPPDTWEvaluator.cs" />
+    <Compile Include="ProblemInstances\SingleDepotVRP\SingleDepotVRPEvaluator.cs" />
     <Compile Include="SolutionParser.cs" />
     <Compile Include="Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedProblemInstance.cs" />
     <Compile Include="Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedOperator.cs" />
-    <Compile Include="Variants\Capacitated\Heterogenous\IHeterogenousCapacitatedEncoding.cs" />
     <Compile Include="Variants\Capacitated\Homogenous\IHomogenousCapacitatedOperator.cs" />
     <Compile Include="Variants\Capacitated\Homogenous\IHomogenousCapacitatedProblemInstance.cs" />
@@ -305,4 +315,6 @@
     <Compile Include="Variants\Capacitated\ICapacitatedOperator.cs" />
     <Compile Include="Variants\General\IGeneralVRPOperator.cs" />
+    <Compile Include="Variants\MultiDepot\IMultiDepotOperator.cs" />
+    <Compile Include="Variants\MultiDepot\IMultiDepotProblemInstance.cs" />
     <Compile Include="Variants\PickupAndDelivery\IPickupAndDeliveryOperator.cs" />
     <Compile Include="Variants\PickupAndDelivery\IPickupAndDeliveryProblemInstance.cs" />
@@ -318,5 +330,4 @@
     <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPTW\CVRPTWEvaluator.cs" />
     <Compile Include="ProblemInstances\SingleDepotVRP\CVRP\CVRPEvaluator.cs" />
-    <Compile Include="ProblemInstances\SingleDepotVRP\SingleDepotVRPEvaluator.cs" />
     <Compile Include="ProblemInstances\VRPEvaluator.cs" />
     <Compile Include="ProblemInstances\VRPEvaluation.cs" />
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs	(revision 6851)
@@ -29,4 +29,6 @@
   public interface IVRPEncoding: IItem {
     List<Tour> GetTours();
+    int GetTourIndex(Tour tour);
+    int GetVehicleAssignment(int tour);
   }
 }
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs	(revision 6851)
@@ -35,5 +35,5 @@
     VRPEvaluation EvaluateTour(IVRPProblemInstance instance, Tour tour, IVRPEncoding solution);
     bool Feasible(VRPEvaluation evaluation);
-    double GetInsertionCosts(IVRPProblemInstance instance, VRPEvaluation eval, int customer, int tour, int index, out bool feasible);
+    double GetInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, VRPEvaluation eval, int customer, int tour, int index, out bool feasible);
   }
 }
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs	(revision 6851)
@@ -48,5 +48,8 @@
     DoubleValue DistanceFactor { get; }
 
-    double GetDistance(int start, int end);
+    double[] GetCoordinates(int city);
+    double GetDemand(int city);
+    double GetDistance(int start, int end, IVRPEncoding solution);
+    double GetInsertionDistance(int start, int customer, int end, IVRPEncoding solution);
     bool Feasible(IVRPEncoding solution);
     bool TourFeasible(Tour tour, IVRPEncoding solution);
@@ -54,5 +57,5 @@
     VRPEvaluation EvaluateTour(Tour tour, IVRPEncoding solution);
     bool Feasible(VRPEvaluation eval);
-    double GetInsertionCosts(VRPEvaluation eval, int customer, int tour, int index, out bool feasible);
+    double GetInsertionCosts(VRPEvaluation eval, IVRPEncoding solution, int customer, int tour, int index, out bool feasible);
   }
 }
